%this script demos the usage of evaluation routines
% the result file 'demo.val.pred.txt' on validation data is evaluated
% against the ground truth

fprintf('CLASSIFICATION TASK\n');

meta_file = '../data/meta_clsloc.mat';
pred_file='demo.val.pred.txt';
ground_truth_file='../data/ILSVRC2013_clsloc_validation_ground_truth.txt';
blacklist_file='../data/ILSVRC2013_clsloc_validation_blacklist.txt';
num_predictions_per_image=5;

fprintf('pred_file: %s\n', pred_file);
fprintf('ground_truth_file: %s\n', ground_truth_file);
fprintf('blacklist_file: %s\n', blacklist_file);

load(meta_file);

%% Classification task
error_flat=zeros(num_predictions_per_image,1);

for i=1:num_predictions_per_image
    error_flat(i) = eval_flat(pred_file,ground_truth_file, i);
end

disp('Classification task: # guesses  vs flat error');
disp([(1:num_predictions_per_image)',error_flat]);

%% Localization task
fprintf('CLASSIFICATION WITH LOCALIZATION TASK\n');
pred_localization_file='demo.val.pred.loc.txt';
ground_truth_file='../data/ILSVRC2013_clsloc_validation_ground_truth.txt';
num_val_files = -1;

fprintf('pred_localization_file: %s\n', pred_localization_file);
fprintf('ground_truth_file: %s\n', ground_truth_file);

while num_val_files ~= 50000
    if num_val_files ~= -1 
        fprintf('That does not seem to be the correct directory. Please try again\n');
    end
    localization_ground_truth_dir=input('Please enter the path to the Validation bounding box annotations directory: ', 's');
    fprintf('localization_ground_truth_dir: %s\n', localization_ground_truth_dir);
    val_files = dir(sprintf('%s/*.xml',localization_ground_truth_dir));
    num_val_files = numel(val_files);
end

error_localization_flat=zeros(num_predictions_per_image,1);

for i=1:num_predictions_per_image
    error_localization_flat(i) = eval_localization_flat(pred_localization_file,ground_truth_file,localization_ground_truth_dir,meta_file,i,blacklist_file);
end

disp('Classification with localization task: # guesses  vs flat error');
disp([(1:num_predictions_per_image)',error_localization_flat]);

